# -*- coding: utf-8 -*-

import mod.client.extraClientApi as clientApi
import testMenuScript.menuConst as MenuConst
import testMenuScript.ui.uiMgr as uiMgr
from mod_log import logger

from testMenuScript.ui.uiDef import UIDef

ClientSystem = clientApi.GetClientSystemCls()


class MenuClientSystem(ClientSystem):
    """
    该mod的客户端类
    根据服务端推送下来的数据显示通用显示界面
    """

    def __init__(self, namespace, systemName):
        ClientSystem.__init__(self, namespace, systemName)
        self.mUIMgr = uiMgr.UIMgr()

        self.ListenForEvent(clientApi.GetEngineNamespace(), clientApi.GetEngineSystemName(), MenuConst.UiInitFinishedEvent, self, self.OnUiInitFinished)
        self.ListenForEvent(MenuConst.ModName, MenuConst.ServerSystemName, "ServerMenuEvent", self, self.OnServerMenu)

    def OnServerMenu(self, args):
        print "OnServerMenu", args
        if self.mUIMgr:
            self.mUIMgr.GetUI(UIDef.MenuScreen).SetData(args["data"])
        else:
            print "UIMgr还没有加载!"

    def Destroy(self):
        self.UnListenForEvent(clientApi.GetEngineNamespace(), clientApi.GetEngineSystemName(), MenuConst.UiInitFinishedEvent, self, self.OnUiInitFinished)
        if self.mUIMgr:
            self.mUIMgr.Destroy()

    # UI加载完成
    def OnUiInitFinished(self, args):
        logger.info("%s OnUiInitFinished", MenuConst.ClientSystemName)
        self.mUIMgr.Init(self)
        self.NotifyToServer("ClientUiLoadedEvent", {})
