# -*- coding: utf-8 -*-
import mod.client.extraClientApi as clientApi

from testMenuScript.menuConst import ModName, ClientSystemName

ScreenNode = clientApi.GetScreenNodeCls()


class MenuScreen(ScreenNode):
    """
    Menu
    """

    def __init__(self, namespace, name, param):
        ScreenNode.__init__(self, namespace, name, param)
        self.mStackPanel = "/stack_panel"
        self.mTemplate = "/btn_tpl"
        print '==== %s ====' % 'init MenuScreen'

    # Create函数是继承自ScreenNode，会在UI创建完成后被调用
    def Create(self):
        print '==== %s ====' % 'MenuScreen Create'

    def OnBtnClick(self, args):
        print args["ButtonPath"]
        path = args["ButtonPath"]  # 路径为 /stack_panel/btn_x/button
        buttonId = int(path[path.rindex("_") + 1:path.index("/button")])  # 截取路径中的x，它就是按钮的索引
        clientApi.GetSystem(ModName, ClientSystemName).NotifyToServer("ClientMenuClickedEvent", {"index": buttonId})  # 发送给服务器

    def SetData(self, data):
        data = sorted(data, key=lambda x: x["index"])
        # 对按钮顺序进行排序
        for btn in data:
            newName = "btn_{}".format(btn["index"])  # 把按钮对应的index存在路径中，后面按钮点击时，根据路径判断是哪个按钮
            self.Clone(self.mTemplate, self.mStackPanel, newName)
            newPath = self.mStackPanel + "/" + newName
            self.GetBaseUIControl(newPath).SetVisible(True)  # 设置可见
            newPath += "/button"
            btnControl = self.GetBaseUIControl(newPath).asButton()
            btnControl.AddTouchEventParams({"isSwallow": True})  # 先开启按钮回调功能
            btnControl.SetButtonTouchUpCallback(self.OnBtnClick)  # 再设置按钮回调函数
            # 按钮的贴图有3个，分别对应默认、按下、悬浮。这里三个都设置。
            self.GetBaseUIControl(newPath + "/default").asImage().SetSprite(btn["texture"])
            self.GetBaseUIControl(newPath + "/pressed").asImage().SetSprite(btn["texture"])
            self.GetBaseUIControl(newPath + "/hover").asImage().SetSprite(btn["texture"])
            self.GetBaseUIControl(newPath + "/button_label").asLabel().SetText(btn["text"])  # 设置按钮下的文本
